---
title: CryptoKeyPair
slug: Web/API/CryptoKeyPair
tags:
  - API
  - CryptoKeyPair
  - Dictionary
  - Reference
  - Web Crypto API
---
<div>{{APIRef("Web Crypto API")}}</div>

<p>The <strong><code>CryptoKeyPair</code></strong> dictionary of the <a href="/en-US/docs/Web/API/Web_Crypto_API">Web Crypto API </a>represents a key pair for an asymmetric cryptography algorithm, also known as a public-key algorithm.</p>

<p>A <code>CryptoKeyPair</code> object can be obtained using {{domxref("SubtleCrypto.generateKey()")}}, when the selected algorithm is one of the asymmetric algorithms: RSASSA-PKCS1-v1_5, RSA-PSS, RSA-OAEP, ECDSA, or ECDH.</p>

<p>It contains two properties, which are both <code><a href="/en-US/docs/Web/API/CryptoKey">CryptoKey</a></code> objects: a <code>privateKey</code> property containing the private key and a <code>publicKey</code> property containing the public key.</p>

<h2 id="Properties">Properties</h2>

<dl>
 <dt><code>CryptoKeyPair.privateKey</code></dt>
 <dd>A <code><a href="/en-US/docs/Web/API/CryptoKey">CryptoKey</a></code> object representing the private key. For encryption and decryption algorithms, this key is used to decrypt. For signing and verification algorithms it is used to sign.</dd>
 <dt><code>CryptoKeyPair.publicKey</code></dt>
 <dd>A <code><a href="/en-US/docs/Web/API/CryptoKey">CryptoKey</a></code> object representing the public key. For encryption and decryption algorithms, this key is used to encrypt. For signing and verification algorithms it is used to verify signatures.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>The examples for <code>SubtleCrypto</code> methods often use <code>CryptoKeyPair</code> objects. For example:</p>

<ul>
 <li><code><a href="/en-US/docs/Web/API/SubtleCrypto/generateKey">SubtleCrypto.generateKey()</a></code></li>
 <li><code><a href="/en-US/docs/Web/API/SubtleCrypto/deriveKey">SubtleCrypto.deriveKey()</a></code></li>
 <li><code><a href="/en-US/docs/Web/API/SubtleCrypto/importKey">SubtleCrypto.importKey()</a></code></li>
 <li><code><a href="/en-US/docs/Web/API/SubtleCrypto/exportKey">SubtleCrypto.exportKey()</a></code></li>
 <li><code><a href="/en-US/docs/Web/API/SubtleCrypto/wrapKey">SubtleCrypto.wrapKey()</a></code></li>
 <li><code><a href="/en-US/docs/Web/API/SubtleCrypto/unwrapKey">SubtleCrypto.unwrapKey()</a></code></li>
 <li><code><a href="/en-US/docs/Web/API/SubtleCrypto/encrypt">SubtleCrypto.encrypt()</a></code></li>
 <li><code><a href="/en-US/docs/Web/API/SubtleCrypto/decrypt">SubtleCrypto.decrypt()</a></code></li>
 <li><code><a href="/en-US/docs/Web/API/SubtleCrypto/sign">SubtleCrypto.sign()</a></code></li>
 <li><code><a href="/en-US/docs/Web/API/SubtleCrypto/verify">SubtleCrypto.verify()</a></code></li>
</ul>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{ SpecName('Web Crypto API', '#dfn-CryptoKeyPair', 'CryptoKeyPair') }}</td>
   <td>{{ Spec2('Web Crypto API') }}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CryptoKeyPair")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("SubtleCrypto.generateKey")}}.</li>
 <li>{{domxref("SubtleCrypto.sign")}} and {{domxref("SubtleCrypto.verify")}}.</li>
 <li>{{domxref("SubtleCrypto.encrypt")}} and {{domxref("SubtleCrypto.decrypt")}}.</li>
</ul>
